Attribute VB_Name = "ModEnvelope_Label"
Option Explicit

Sub PrintEnvelope_Label()
'Graham Mayor - www.gmayor.com
'An Outlook Macro
Dim i As Long
Dim oExp As Outlook.Explorer
Dim objSel As Outlook.Selection
Dim objFolder As Outlook.MAPIFolder
Dim objContact As Outlook.ContactItem
Dim strAddress As String
Dim wdApp As Object
Dim wdDoc As Object
Dim bWordWasNotRunning As Boolean
Dim strEnvPath As String
Dim strLabelPath As String
Dim oTable As Object
Dim oCell As Object
Dim iCol As Integer
Dim iRow As Integer
Dim oRng As Object
Dim oEnvForm As New frmEnv_Label

    On Error Resume Next
    strEnvPath = "Outlook Envelope.docx"
    strLabelPath = "Outlook Label.docx"
    Set oExp = Outlook.ActiveExplorer
    Set objFolder = oExp.CurrentFolder
    Set objSel = oExp.Selection

    If oExp.Selection.Count > 0 Then
        Set objContact = oExp.Selection.Item(1)
        If Err Then
            Err.Clear
            MsgBox "Select a contact first!", vbCritical, "Print Envelope/Label"
            GoTo lbl_Exit
        End If
    Else
        MsgBox "Select a contact first!", vbCritical, "Print Envelope/Label"
        GoTo lbl_Exit
    End If

    strEnvPath = Environ("USERPROFILE") & Chr(92) & "Documents" & Chr(92) & strEnvPath
    strLabelPath = Environ("USERPROFILE") & Chr(92) & "Documents" & Chr(92) & strLabelPath

    If Not FileExists(strEnvPath) Then
        MsgBox "Envelope Template" & vbCr & strEnvPath & vbCr & "is not available", vbCritical, "Print Envelope/Label"
        GoTo lbl_Exit
    End If
    If Not FileExists(strLabelPath) Then
        MsgBox "Label Template" & vbCr & strLabelPath & vbCr & "is not available", vbCritical, "Print Envelope/Label"
        GoTo lbl_Exit
    End If
    With oEnvForm
        strAddress = ""
        If objSel.Item(1).Class = olContact Then
            Set objContact = objSel.Item(1)
            With objContact
                If .FullName <> "" Then
                    strAddress = strAddress & .FullName & vbCr
                End If
                If .CompanyName <> "" Then
                    strAddress = strAddress & .CompanyName & vbCr
                End If
                strAddress = strAddress & .MailingAddress
            End With
        End If
        With .LabelNote
            .ForeColor = &HC00000
            .TextAlign = fmTextAlignLeft
            .Caption = "Print an envelope for: "
        End With
        With .TBAddress
            .MultiLine = True
            .Font.Size = 10
            .Font.Bold = False
            .ForeColor = &H80000012
            .TextAlign = fmTextAlignLeft
            .Text = strAddress
        End With
        .LBRow.Enabled = False
        .LBRow.Visible = False
        .LBCol.Visible = False
        .LblCols.Visible = False
        .LblRows.Visible = False
        .TBRows.Value = GetSetting("Outlook Envelope", "Table", "Rows")
        If .TBRows.Value = "" Then .TBRows.Value = 8
        .TBRows.Visible = False
        .TBCols.Value = GetSetting("Outlook Envelope", "Table", "Columns")
        If .TBCols.Value = "" Then .TBCols.Value = 3
        .TBCols.Visible = False
        .ChkFullPage.Visible = False
        .LabelFullPage.Caption = ""
        .Label1.Caption = ""
        .Label2.Caption = ""
        .Label3.Caption = ""
        .Height = 227
        .CBCancel.Top = .Height - 63
        .CBOK.Top = .Height - 63
        .Show
        If .Tag = 0 Then GoTo lbl_Exit
        
        bWordWasNotRunning = False
        Set wdApp = GetObject(, "Word.Application")
        If Err Then
            Set wdApp = CreateObject("Word.Application")
            bWordWasNotRunning = True
        End If
        wdApp.Visible = True
        If .OptEnv.Value = True Then
            Set wdDoc = wdApp.Documents.Open(strEnvPath)
            wdDoc.Variables("varAddress").Value = .TBAddress.Text
            wdDoc.Fields.Update
            With wdApp
                .DisplayAlerts = 0
                .PrintOut Background:=False, Pages:="0"
                .DisplayAlerts = -1
            End With
        ElseIf .OptLabel.Value = True Then
            Set wdDoc = wdApp.Documents.Open(strLabelPath)
            Set oTable = wdDoc.Tables(1)
            If .ChkFullPage.Value = True Then
                For Each oCell In oTable.Range.Cells
                    If oCell.Width = oTable.Cell(1, 1).Width Then
                        Set oRng = oCell.Range
                        oRng.End = oRng.End - 1
                        oRng.Text = .TBAddress.Text
                    End If
                Next oCell
            Else
                iRow = .LBRow.Value
                If oTable.Cell(1, 1).Height > oTable.Cell(2, 1).Height Then
                    iRow = iRow + (iRow - 1)
                End If

                iCol = .LBCol.Value
                If oTable.Cell(1, 1).Width > oTable.Cell(1, 2).Width Then
                    iCol = iCol + (iCol - 1)
                End If

                Set oRng = oTable.Cell(iRow, iCol).Range
                oTable.Cell(iRow, iCol).VerticalAlignment = 1
                oRng.End = oRng.End - 1
                oRng.Text = .TBAddress.Text
            End If

            With wdApp
                .DisplayAlerts = 0
                .PrintOut Background:=False
                .DisplayAlerts = 1
            End With
        End If
        wdDoc.Close 0
CleanUp:
    End With
lbl_Exit:
    Unload oEnvForm
    If bWordWasNotRunning = True Then
        wdApp.Quit
    End If
    Set oExp = Nothing
    Set objFolder = Nothing
    Set objSel = Nothing
    Set objContact = Nothing
    Set wdDoc = Nothing
    Set wdApp = Nothing
    Set oRng = Nothing
    Exit Sub
err_Handler:
    Err.Clear
    GoTo lbl_Exit
End Sub

Private Function FileExists(strFullName As String) As Boolean
'Graham Mayor - www.gmayor.com
'strFullName is the name with path of the file to check
Dim fso As Object
    Set fso = CreateObject("Scripting.FileSystemObject")
    If fso.FileExists(strFullName) Then
        FileExists = True
    Else
        FileExists = False
    End If
lbl_Exit:
    Set fso = Nothing
    Exit Function
End Function
